;PC98.ASM - PC98 Emu(start) and load HDMBR
	ASSUME  CS:CODE,DS:CODE,ES:CODE
CODE    SEGMENT
    ORG 100h
START:
    JMP IPL_START

LOADSECT DW 0004h
LOADSCT2 DW 0002h
TMP DW  0
MEM DW  0
CNT DB  64 ;Memory size 512*cnt 64=32M mem
NOZ DB  0
WS  DB  0

    PSEG    EQU 0000H
    POFF    EQU 7C00H
    COLR    EQU 000Fh

    ;NormalPC98
    ;WA1 EQU 128     ;pipo
    ;WA2 EQU 2048    ;from pipo to memcheck
    ;WA3 EQU 24      ;memcheck
    ;WA1 EQU 3
    ;WA2 EQU 27
    ;WA3 EQU 1

    ;FastPC98
    ;WA1 EQU 32      ;pipo
    ;WA2 EQU 512     ;from pipo to memcheck
    ;WA3 EQU 16      ;memcheck
    ;WA1 EQU 1
    ;WA2 EQU 18
    ;WA3 EQU 1

    ;Normal(memslow)PC98
    ;WA1 EQU 128     ;pipo
    ;WA2 EQU 2048    ;from pipo to memcheck
    ;WA3 EQU 64      ;memcheck
    WA1 EQU 3
    WA2 EQU 27
    WA3 EQU 2

    ;WA4 EQU 4096    ;after memcheck
    ;WA5 EQU 2048    ;after scr_clear
    WA4 EQU 27
    WA5 EQU 18

IPL_START:
    mov ax,0E21h
    int 10h

    MOV     AX,8000h
    MOV     ES,AX

	CLI
    MOV     AX,8000H
	MOV     SS,AX
    XOR     SP,SP
    STI

    MOV AX,0002h
    int 10h

    MOV AH,01H
    MOV CX,2000h;0007H
    INT 10H

    PUSH ES
    MOV AX,9000h
    MOV ES,AX

    mov tmp,8
    xor bx,bx
    mov cx,LOADSECT
    mov dx,0080h
rfnt:
    mov ax,0201h
    int 13h
    call ads
    dec tmp
    jnz rfnt

    MOV AX,1100H
    MOV BH,16
    MOV BL,0
    MOV CX,256
    MOV DX,0
    MOV BP,0
    INT 10H
    POP ES
;START PROGRAM===============================================================
    MOV AX,1301H
    MOV BP,OFFSET STR1
    MOV CX,LEN1
    XOR DX,DX
    MOV BX,COLR
    INT 10H

    MOV AX,1301H
    MOV BP,OFFSET STR3
    MOV CX,LEN3
    MOV DX,LEN1
    MOV BX,COLR
    INT 10H

    MOV ax,600
    CALL    BEEP
    MOV ax,1200
    CALL    BEEP

    MOV CX,WA2
    CALL    waiter

    mov MEM,512
;printing numeric================================
renum:
    MOV AX,1301H
    MOV BP,OFFSET STR2
    MOV CX,LEN2
    MOV DX,LEN1
    MOV BX,COLR
    INT 10H

    MOV DX,MEM

    MOV     NOZ,0
    MOV     TMP,10000
    CALL    PRNUM

    MOV     TMP,1000
    CALL    PRNUM

    MOV     NOZ,1
    MOV     TMP,100
    CALL    PRNUM

    MOV     NOZ,1
    MOV     TMP,10
    CALL    PRNUM

    MOV     NOZ,1
    MOV     TMP,1
    CALL    PRNUM

    mov ah,03h
    mov bh,0
    int 10h

    MOV AX,1301H
    MOV BP,OFFSET STR3
    MOV CX,LEN3
    MOV BX,COLR
    INT 10H

    MOV CX,WA3
    CALL    waiter

    ADD MEM,512

    DEC CNT
    JZ  SkRENUM
    JMP RENUM

SkRENUM:
    MOV CX,WA4
    CALL    waiter

    MOV AX,0002h
    INT 10h
    MOV AH,01H
    MOV CX,2000H
    INT 10H

    MOV CX,WA5
    CALL    waiter
;LOAD MBR====================================================================
    PUSH ES
    MOV AX,PSEG
    MOV ES,AX
    MOV BX,POFF

    ;T:S,H:D
    MOV CX,CS:LOADSCT2
    MOV DX,0080h

    MOV AX,0201H
    INT 13H

    POP ES
;RUN PROGRAM=================================================================
    mov ax,0002h
    int 10h

    MOV AX,PSEG
    MOV ES,AX

    MOV AX,PSEG
    MOV DS,AX
    MOV ES,AX

    JMP PSEG:[POFF]
ADS:
;ADD SECT
    INC CL
    ADD BX,0200H
    CMP CL,19
    JNZ READSKIP

    MOV CL,1
;ADD HEAD
    INC DH

    CMP DH,2
    JNZ READSKIP

    XOR DH,DH
;ADD CYL(TRK)
    INC CH
READSKIP:
    RET
;PC98SUB=====================================================================
Beep:
    ;SetFreq:ax=(hz)
	MOV		BX,AX

	MOV		AL,0B6h
    OUT     043h,AL
	MOV		AX,BX
    OUT     042h,AL
	MOV		AL,AH
    OUT     042h,AL
    ;BeepON
    IN      AL,61h
    OR      AL,03h
    OUT     61h,AL

    MOV CX,WA1
    CALL    waiter

    ;BeepOF
    IN      AL,61h
    AND     AL,0FCh
    OUT     61h,AL

    RET
;PWAIT:
;    PUSH    CX
;    MOV     CX,32767
;    PW2:
;        NOP
;        LOOP    PW2
;    POP     CX
;    LOOP    PWAIT
;
;    RET
waiter:
    mov ws,cl

    mov ah,0
    int 1ah
    mov bx,dx
waiter_lop:
    mov ah,0
    int 1ah
    cmp bx,dx
    jz waiter_lop
    mov bx,dx
    dec ws
    cmp ws,0
    jnz waiter_lop

    ret
PrNum:
    MOV     AX,DX
    XOR     DX,DX
    DIV     TMP

    CMP     AL,0
    JNZ     CONTNUM

    CMP     NOZ,0
    JZ      RETNUM 
CONTNUM:
    MOV     NOZ,AL

    MOV     AH,09h
    MOV     CX,1
    MOV     BX,COLR
    ADD     AL,48
    INT     10h

    PUSH    DX
    MOV     AH,03h
    int     10h
    inc     dl
    mov     aH,02h
    int     10h
    POP     DX
RETNUM:
    RET

STR1    DB  "MEMORY 640"
LEN1    EQU $-STR1
STR2    DB  " KB + "
LEN2    EQU $-STR2
STR3    DB  " KB OK"
LEN3    EQU $-STR3

CODE    ENDS
    END     START
