    ASSUME  CS:CODE,DS:CODE,ES:CODE
CODE    segment
start:
    JMP IPL_START

	;SIGNATURE
    DB  '$PC9801$'

	DB  00,02,01,01,00
	DB  02,0E0h,00,40h,0Bh,0F0h,09,00,12h,00,02,0,0,0,0,0
	DB  0,0,0,0,0,0,29h
	DB  0FFh,0FFh,0FFh,0FFh
	DB  "NO NAME    FAT12   "

TMP DW  0
MEM DW  0
CNT DB  64 ;Memory size 512*cnt
NOZ DB  0

IPL_START:
    MOV     AX,07B0h
	MOV     DS,AX
	MOV     ES,AX

	CLI
    MOV     AX,07B0h
	MOV     SS,AX
    XOR     SP,SP
	STI

    MOV AX,1301H
    MOV BP,OFFSET STR1
    MOV CX,LEN1
    XOR DX,DX
    MOV BX,0007H
    INT 10H

    MOV AX,1301H
    MOV BP,OFFSET STR3
    MOV CX,LEN3
    MOV DX,LEN1
    MOV BX,0007H
    INT 10H

    MOV ax,1300
    CALL    BEEP
    MOV ax,2000
    CALL    BEEP

    MOV CX,1024
    CALL    PWAIT

    mov MEM,512
;printing numeric================================
renum:
    MOV AX,1301H
    MOV BP,OFFSET STR2
    MOV CX,LEN2
    MOV DX,LEN1
    MOV BX,0007H
    INT 10H

    MOV DX,MEM

    MOV     NOZ,0
    MOV     TMP,10000
    CALL    PRNUM

    MOV     TMP,1000
    CALL    PRNUM

    MOV     NOZ,1
    MOV     TMP,100
    CALL    PRNUM

    MOV     NOZ,1
    MOV     TMP,10
    CALL    PRNUM

    MOV     NOZ,1
    MOV     TMP,1
    CALL    PRNUM

    mov ah,03h
    mov bh,0
    int 10h

    MOV AX,1301H
    MOV BP,OFFSET STR3
    MOV CX,LEN3
    MOV BX,0007H
    INT 10H

    MOV CX,32
    CALL    PWAIT

    ADD MEM,512

    DEC CNT
    JZ  SkRENUM
    JMP RENUM

SkRENUM:
    MOV CX,2048
    CALL    PWAIT
;testbeep==================
    MOV ax,1360
    CALL    BEEP
;restart===================
    XOR AX,AX
    INT 16h
    INT 19h
;Sub rootin================
Beep:
    ;SetFreq:ax=(hz)
	MOV		BX,AX

	MOV		AL,0B6h
    OUT     043h,AL
	MOV		AX,BX
    OUT     042h,AL
	MOV		AL,AH
    OUT     042h,AL
    ;BeepON
    IN      AL,61h
    OR      AL,03h
    OUT     61h,AL

    MOV CX,128
    CALL    PWAIT

    ;BeepOF
    IN      AL,61h
    AND     AL,0FCh
    OUT     61h,AL

    RET
PWAIT:
    PUSH    CX
    MOV     CX,32767
    PW2:
        NOP
        LOOP    PW2
    POP     CX
    LOOP    PWAIT

    RET
PrNum:
    MOV     AX,DX
    XOR     DX,DX
    DIV     TMP

    CMP     AL,0
    JNZ     CONTNUM

    CMP     NOZ,0
    JZ      RETNUM 
CONTNUM:
    MOV     NOZ,AL

    MOV     AH,0Eh
    ADD     AL,48
    INT     10h
RETNUM:
    RET

STR1    DB  "MEMORY 640"
LEN1    EQU $-STR1
STR2    DB  " KB + "
LEN2    EQU $-STR2
STR3    DB  " KB OK"
LEN3    EQU $-STR3

ORG 2FEh
    DB  055h,0AAh
CODE    ENDS
    END START
